"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.getWidth = void 0;

var _map2 = _interopRequireDefault(require("ramda/src/map"));

var _length2 = _interopRequireDefault(require("ramda/src/length"));

var _subtract2 = _interopRequireDefault(require("ramda/src/subtract"));

var _merge2 = _interopRequireDefault(require("ramda/src/merge"));

var _without2 = _interopRequireDefault(require("ramda/src/without"));

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _eachDayOfInterval = _interopRequireDefault(require("date-fns/eachDayOfInterval"));

var _isSameDay = _interopRequireDefault(require("date-fns/isSameDay"));

var _isBefore = _interopRequireDefault(require("date-fns/isBefore"));

var _startOfMonth = _interopRequireDefault(require("date-fns/startOfMonth"));

var _endOfMonth = _interopRequireDefault(require("date-fns/endOfMonth"));

var _CalendarMonth = _interopRequireDefault(require("./CalendarMonth"));

var _ArrowLeft = _interopRequireDefault(require("./ArrowLeft"));

var _ArrowRight = _interopRequireDefault(require("./ArrowRight"));

var utils = _interopRequireWildcard(require("./utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _templateObject8() {
  var data = _taggedTemplateLiteral(["\n  right: 0;\n"]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = _taggedTemplateLiteral(["\n  left: 0;\n"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = _taggedTemplateLiteral(["\n  margin-right: 10px;\n  &:last-child {\n    margin-right: 0;\n  }\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = _taggedTemplateLiteral(["\n  border: 1px solid ", ";\n  position: absolute;\n  background: ", ";\n  border-radius: 2px;\n  width: 43px;\n  height: 30px;\n  cursor: pointer;\n  :hover {\n    background: ", ";\n  }\n  &:focus {\n    outline: none;\n  }\n  :disabled {\n    cursor: not-allowed;\n    :hover {\n      background: initial;\n    }\n  }\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n  position: relative;\n  margin: 0 auto;\n  text-align: center;\n  max-width: ", ";\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  position: absolute;\n  top: 5px;\n  right: 12.5px;\n  fill: #82888a;\n  width: 18px;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  position: absolute;\n  top: 5px;\n  left: 12.5px;\n  fill: #82888a;\n  width: 18px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var defaultColors = {
  selected: "rgb(244, 114, 49)",
  selectedHover: "rgb(255, 141, 74)",
  border: "#e4e7e7",
  background: "white",
  hover: "#e4e7e7",
  disabled: "gray"
};
var StyledArrowLeft = (0, _styledComponents.default)(_ArrowLeft.default)(_templateObject());
var StyledArrowRight = (0, _styledComponents.default)(_ArrowRight.default)(_templateObject2());

var getWidth = function getWidth(visibleMonths, width) {
  return "".concat(width * visibleMonths, "px");
}; // 321 - 20 = 301 : 20 = margin


exports.getWidth = getWidth;

var CalendarWrapper = _styledComponents.default.div(_templateObject3(), function (props) {
  return getWidth(props.visibleMonths, props.width);
});

var CalendarMonthWrapper = _styledComponents.default.div(_templateObject4());

var NavBtn = _styledComponents.default.button(_templateObject5(), function (props) {
  return props.colors.border;
}, function (props) {
  return props.colors.background;
}, function (props) {
  return props.colors.border;
});

var StyledMonth = (0, _styledComponents.default)(_CalendarMonth.default)(_templateObject6());
var PrevBtn = (0, _styledComponents.default)(NavBtn)(_templateObject7());
var NextBtn = (0, _styledComponents.default)(NavBtn)(_templateObject8());

var Calendar =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Calendar, _React$PureComponent);

  function Calendar(props) {
    var _this;

    _classCallCheck(this, Calendar);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Calendar).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleNext", function () {
      _this.setState(function (state) {
        return {
          currentMonth: state.currentMonth + 1
        };
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handlePrev", function () {
      _this.setState(function (state) {
        return {
          currentMonth: state.currentMonth - 1
        };
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleSetCurrentMonth", function (nextProps, nextState) {
      var _this$props = _this.props,
          firstMonth = _this$props.firstMonth,
          lastMonth = _this$props.lastMonth,
          future = _this$props.future,
          visibleMonths = _this$props.visibleMonths; // if date wasn't selected internally (it means that selectedDates
      // was changed from parent component ) then calculate current month and set it
      // also set selectedInternally to false

      if (!nextState.selectedInternally) {
        var currentMonth = utils.getCurrentMonthIndex(firstMonth, lastMonth, nextProps.selectedDates, future, visibleMonths); // eslint-disable-next-line react/no-unused-state

        _this.setState({
          selectedInternally: false,
          currentMonth: currentMonth
        }); // }
        // otherwise just set selectedInternally to false, so we can determine if next
        // date select will be done in this component or in parent component

      } else {
        // eslint-disable-next-line react/no-unused-state
        _this.setState({
          selectedInternally: false
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleSetRange", function (date) {
      var start = _this.state.start;
      var _this$props2 = _this.props,
          disabledDates = _this$props2.disabledDates,
          selectDates = _this$props2.selectDates; // when someting is already selected (start)
      // and we clicked on some date (date)
      // then we will set array of dates between
      // date and start - it depends which one is first
      // selected array of dates is sorted ascending

      if (date && start) {
        // eslint-disable-next-line react/no-unused-state
        _this.setState({
          selectedInternally: true
        });

        if ((0, _isBefore.default)(date, start)) {
          var range = (0, _eachDayOfInterval.default)({
            start: date,
            end: start
          });
          selectDates((0, _without2.default)(disabledDates, range));
        } else {
          var _range = (0, _eachDayOfInterval.default)({
            start: start,
            end: date
          });

          selectDates((0, _without2.default)(disabledDates, _range));
        }
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleSelect", function (date) {
      var _this$props3 = _this.props,
          disabledDates = _this$props3.disabledDates,
          rangeSelect = _this$props3.rangeSelect,
          selectDates = _this$props3.selectDates;
      var _this$state = _this.state,
          isFocused = _this$state.isFocused,
          end = _this$state.end,
          start = _this$state.start; // when something is already selected

      if (isFocused && rangeSelect) {
        _this.setState({
          end: date,
          isFocused: false,
          hoveredDates: [],
          // eslint-disable-next-line react/no-unused-state
          selectedInternally: true
        });

        _this.handleSetRange(date); // when unselecting date

      } else if ( // $FlowExpected
      (0, _isSameDay.default)(date, end) && // $FlowExpected
      (0, _isSameDay.default)(end, start)) {
        _this.setState({
          start: null,
          end: null,
          isFocused: false,
          // eslint-disable-next-line react/no-unused-state
          selectedInternally: true
        });

        selectDates([]); // initial select case
      } else {
        _this.setState({
          start: date,
          isFocused: true,
          // eslint-disable-next-line react/no-unused-state
          selectedInternally: true
        });

        selectDates((0, _without2.default)(disabledDates, [date]));
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleHover", function (date) {
      var rangeSelect = _this.props.rangeSelect;
      var _this$state2 = _this.state,
          isFocused = _this$state2.isFocused,
          start = _this$state2.start;

      if (start && date && isFocused && rangeSelect) {
        if ((0, _isBefore.default)(date, start)) {
          _this.setState({
            hoveredDates: (0, _eachDayOfInterval.default)({
              start: date,
              end: start
            })
          });
        } else {
          _this.setState({
            hoveredDates: (0, _eachDayOfInterval.default)({
              start: start,
              end: date
            })
          });
        }
      }
    });

    _this.state = {
      end: null,
      hoveredDates: [],
      currentMonth: utils.getCurrentMonthIndex(props.firstMonth, props.lastMonth, props.selectedDates, props.future, props.visibleMonths),
      isFocused: false,
      start: null,
      // eslint-disable-next-line react/no-unused-state
      selectedInternally: false
    };
    return _this;
  }

  _createClass(Calendar, [{
    key: "componentWillUpdate",
    value: function componentWillUpdate(nextProps, nextState) {
      var selectedDates = this.props.selectedDates; // when selectedDates came as a props, we need to know if they were changed
      // if they were, then we have to determine if they were changed internally
      // or externaly (from parent component)

      if (nextProps.selectedDates !== selectedDates) {
        this.handleSetCurrentMonth(nextProps, nextState);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          visibleMonths = _this$props4.visibleMonths,
          selectedDates = _this$props4.selectedDates,
          disabledDates = _this$props4.disabledDates,
          allowedDates = _this$props4.allowedDates,
          colors = _this$props4.colors,
          className = _this$props4.className,
          classes = _this$props4.classes,
          past = _this$props4.past,
          future = _this$props4.future,
          firstMonth = _this$props4.firstMonth,
          lastMonth = _this$props4.lastMonth,
          showMonthName = _this$props4.showMonthName,
          showWeekDayNames = _this$props4.showWeekDayNames,
          customClasses = _this$props4.customClasses,
          weekDayFormat = _this$props4.weekDayFormat,
          weekDayFormatter = _this$props4.weekDayFormatter,
          monthNameFormatter = _this$props4.monthNameFormatter,
          CustomTd = _this$props4.CustomTd,
          width = _this$props4.width,
          buttonBack = _this$props4.buttonBack,
          buttonForward = _this$props4.buttonForward,
          firstWeekDay = _this$props4.firstWeekDay;
      var _this$state3 = this.state,
          currentMonth = _this$state3.currentMonth,
          hoveredDates = _this$state3.hoveredDates,
          isFocused = _this$state3.isFocused;
      var mergedColors = (0, _merge2.default)(defaultColors, colors);
      var months = utils.getMonths(firstMonth, lastMonth);
      return React.createElement(CalendarWrapper, {
        className: className,
        visibleMonths: visibleMonths,
        width: width
      }, months.length > visibleMonths && React.createElement(PrevBtn, {
        "data-test": "rdl-prev-button",
        className: classes.button || "",
        onClick: this.handlePrev,
        disabled: currentMonth === 0 || months.length <= visibleMonths,
        colors: mergedColors
      }, buttonBack ? React.cloneElement(buttonBack, {
        disabled: currentMonth === 0 || months.length <= visibleMonths
      }) : React.createElement(StyledArrowLeft, null)), months.length > visibleMonths && React.createElement(NextBtn, {
        "data-test": "rdl-next-button",
        className: classes.button || "",
        onClick: this.handleNext,
        disabled: currentMonth === (0, _subtract2.default)((0, _length2.default)(months), visibleMonths) || months.length <= visibleMonths,
        colors: mergedColors
      }, buttonForward ? React.cloneElement(buttonForward, {
        disabled: currentMonth === (0, _subtract2.default)((0, _length2.default)(months), visibleMonths) || months.length <= visibleMonths
      }) : React.createElement(StyledArrowRight, null)), React.createElement(CalendarMonthWrapper, {
        className: classes.calendarWrapper || ""
      }, (0, _map2.default)(function (month) {
        return React.createElement(StyledMonth, {
          key: month,
          month: month,
          CustomTd: CustomTd,
          selectedDates: selectedDates,
          disabledDates: disabledDates,
          allowedDates: allowedDates,
          selectDate: _this2.handleSelect,
          onHover: _this2.handleHover,
          hoveredDates: hoveredDates,
          past: past,
          isFocused: isFocused,
          future: future,
          colors: mergedColors,
          classes: classes,
          showMonthName: showMonthName,
          showWeekDayNames: showWeekDayNames,
          weekDayFormat: weekDayFormat,
          weekDayFormatter: weekDayFormatter,
          monthNameFormatter: monthNameFormatter,
          customClasses: utils.filterCustomClasses((0, _startOfMonth.default)(month), (0, _endOfMonth.default)(month))(customClasses),
          width: width,
          firstWeekDay: firstWeekDay
        });
      }, utils.calendarMonthsToRender(visibleMonths, currentMonth, months))));
    }
  }]);

  return Calendar;
}(React.PureComponent);

_defineProperty(Calendar, "defaultProps", {
  disabledDates: [],
  allowedDates: [],
  visibleMonths: 1,
  colors: {},
  className: "",
  classes: {},
  future: true,
  past: true,
  rangeSelect: false,
  showMonthName: true,
  showWeekDayNames: true,
  customClasses: {},
  weekDayFormat: "E",
  width: 301,
  firstWeekDay: 0
});

var _default = Calendar;
exports.default = _default;