"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.getHoverColor = exports.getHover = exports.buttonBg = exports.buttonColor = void 0;

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  display: table-cell;\n  border: ", ";\n  box-sizing: border-box;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  width: 100%;\n  height: 40px;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  opacity: ", ";\n  color: ", ";\n  background: ", ";\n  border: none;\n  font-size: inherit;\n\n  ", ";\n  border-radius: 0;\n  :hover {\n    color: ", ";\n    background: ", ";\n  }\n  :disabled {\n    cursor: default;\n    :hover {\n      background: inherit;\n    }\n  }\n  :focus {\n    outline: none;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

// export const getClasses = (props: Props) => {
//   if (props.isPast || props.isFuture || props.isDisabled) {
//     return props.classes.disabled;
//   }
//   if (props.isHovered) {
//     return props.classes.selected;
//   }
//   if (props.isSelected) {
//     return props.classes.selected;
//   }
//   return props.classes.date;
// };
var buttonColor = function buttonColor(props) {
  if (props.className) {
    return "inherit";
  }

  if (props.disabled) {
    return props.colors.disabled;
  }

  if (props.isHovered) {
    return "white";
  }

  if (props.isSelected) {
    return "white";
  }

  return "inherit";
};

exports.buttonColor = buttonColor;

var buttonBg = function buttonBg(props) {
  if (props.className) {
    return "inherit";
  }

  if (props.disabled) {
    return props.colors.background;
  }

  if (props.isHovered) {
    return props.colors.selected;
  }

  if (props.isSelected) {
    return props.colors.selected;
  }

  return "white";
};

exports.buttonBg = buttonBg;

var getHover = function getHover(props) {
  if (props.isHovered || props.isFocused) {
    return props.colors.selected;
  }

  if (props.isSelected) {
    return props.colors.selectedHover;
  }

  return props.colors.hover;
};

exports.getHover = getHover;

var getHoverColor = function getHoverColor(props) {
  if (props.disabled) {
    return props.colors.disabled;
  }

  if (props.isFocused || props.isSelected) {
    return "white";
  }

  return "inherit";
};

exports.getHoverColor = getHoverColor;

var Button = _styledComponents.default.button(_templateObject(), function (props) {
  return props.isHidden ? 0 : 1;
}, function (props) {
  return buttonColor(props);
}, function (props) {
  return buttonBg(props);
}, function (props) {
  return !props.isHidden && "cursor: pointer;";
}, function (props) {
  return getHoverColor(props);
}, function (props) {
  return getHover(props);
});

var Td = _styledComponents.default.div(_templateObject2(), function (props) {
  return props.isHidden ? "none" : "1px solid ".concat(props.colors.border);
});

var CalendarDay =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(CalendarDay, _React$PureComponent);

  function CalendarDay() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, CalendarDay);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(CalendarDay)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleClick", function () {
      var _this$props = _this.props,
          value = _this$props.value,
          isHidden = _this$props.isHidden,
          selectDate = _this$props.selectDate;

      if (!isHidden) {
        selectDate(value);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleHover", function () {
      var _this$props2 = _this.props,
          value = _this$props2.value,
          isHidden = _this$props2.isHidden,
          onHover = _this$props2.onHover;

      if (!isHidden) {
        onHover(value);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "props", void 0);

    return _this;
  }

  _createClass(CalendarDay, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          isHidden = _this$props3.isHidden,
          number = _this$props3.number,
          isPast = _this$props3.isPast,
          isFuture = _this$props3.isFuture,
          isSelected = _this$props3.isSelected,
          isDisabled = _this$props3.isDisabled,
          isHovered = _this$props3.isHovered,
          colors = _this$props3.colors,
          isFocused = _this$props3.isFocused,
          customClasses = _this$props3.customClasses,
          classes = _this$props3.classes;

      if (classes.day) {
        customClasses.push(classes.day);
      }

      return React.createElement(Td, {
        isHidden: isHidden,
        colors: colors,
        className: customClasses && !isHovered && !isSelected && customClasses.join(" ") || classes.day
      }, React.createElement(Button // className={getClasses(this.props)}
      , {
        onClick: this.handleClick,
        onMouseOver: this.handleHover,
        onFocus: this.handleHover,
        disabled: isPast || isFuture || isDisabled,
        isSelected: isSelected,
        isHidden: isHidden,
        isPast: isPast,
        isFuture: isFuture,
        isHovered: isHovered,
        isDisabled: isDisabled,
        colors: colors,
        isFocused: isFocused,
        number: number
      }, number));
    }
  }]);

  return CalendarDay;
}(React.PureComponent);

exports.default = CalendarDay;