"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _splitEvery2 = _interopRequireDefault(require("ramda/src/splitEvery"));

var _keys2 = _interopRequireDefault(require("ramda/src/keys"));

var _isEmpty2 = _interopRequireDefault(require("ramda/src/isEmpty"));

var _map2 = _interopRequireDefault(require("ramda/src/map"));

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _format = _interopRequireDefault(require("date-fns/format"));

var _getDate = _interopRequireDefault(require("date-fns/getDate"));

var _isSameMonth = _interopRequireDefault(require("date-fns/isSameMonth"));

var _CalendarDay = _interopRequireDefault(require("./CalendarDay"));

var utils = _interopRequireWildcard(require("./utils"));

var dayHelpers = _interopRequireWildcard(require("./utils/dayHelpers"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _templateObject5() {
  var data = _taggedTemplateLiteral(["\n  height: 30px;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n  width: 43px;\n  text-align: center;\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n  margin: 40px 0 10px;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  width: ", ";\n  display: table;\n  border-collapse: collapse;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  display: table-row;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Week = _styledComponents.default.div(_templateObject());

var Month = _styledComponents.default.div(_templateObject2(), function (_ref) {
  var width = _ref.width;
  return "".concat(width, "px");
});

var DayNameList = _styledComponents.default.div(_templateObject3());

var DayName = _styledComponents.default.span(_templateObject4());

var MonthName = _styledComponents.default.span(_templateObject5());

var CalendarMonth = function CalendarMonth(_ref2) {
  var month = _ref2.month,
      selectedDates = _ref2.selectedDates,
      disabledDates = _ref2.disabledDates,
      allowedDates = _ref2.allowedDates,
      selectDate = _ref2.selectDate,
      onHover = _ref2.onHover,
      hoveredDates = _ref2.hoveredDates,
      past = _ref2.past,
      future = _ref2.future,
      colors = _ref2.colors,
      classes = _ref2.classes,
      isFocused = _ref2.isFocused,
      _ref2$className = _ref2.className,
      className = _ref2$className === void 0 ? "" : _ref2$className,
      showMonthName = _ref2.showMonthName,
      showWeekDayNames = _ref2.showWeekDayNames,
      _ref2$customClasses = _ref2.customClasses,
      customClasses = _ref2$customClasses === void 0 ? {} : _ref2$customClasses,
      CustomTd = _ref2.CustomTd,
      weekDayFormat = _ref2.weekDayFormat,
      weekDayFormatter = _ref2.weekDayFormatter,
      monthNameFormatter = _ref2.monthNameFormatter,
      width = _ref2.width,
      firstWeekDay = _ref2.firstWeekDay;
  var toRender = utils.calendarDaysToRender(firstWeekDay, month);
  var Day = CustomTd || _CalendarDay.default;
  return React.createElement("div", {
    className: "".concat(classes.month && classes.month, " ").concat(className)
  }, showMonthName && React.createElement(MonthName, {
    className: classes.monthName
  }, monthNameFormatter ? monthNameFormatter(month) : (0, _format.default)(month, "MMMM yyyy")), showWeekDayNames && React.createElement(DayNameList, null, (0, _map2.default)(function (day) {
    return React.createElement(DayName, {
      key: day,
      className: classes.weekDay
    }, weekDayFormatter ? weekDayFormatter(day) : (0, _format.default)(day, weekDayFormat));
  }, utils.calendarDayNames(toRender))), React.createElement(Month, {
    width: width
  }, (0, _map2.default)(function (week) {
    return React.createElement(Week, {
      key: week
    }, (0, _map2.default)(function (day) {
      return React.createElement(Day, {
        key: day,
        isHidden: !(0, _isSameMonth.default)(month, day),
        number: (0, _getDate.default)(day),
        value: day,
        selectDate: selectDate,
        onHover: onHover,
        isHovered: dayHelpers.isHovered(day, hoveredDates),
        isSelected: dayHelpers.isSelected(day, selectedDates),
        isDisabled: dayHelpers.isDisabled(day, disabledDates) || !(0, _isEmpty2.default)(allowedDates) && !dayHelpers.isDisabled(day, allowedDates),
        isPast: dayHelpers.isPast(day, new Date()) && !past,
        isFuture: dayHelpers.isFuture(day, new Date()) && !future,
        isFocused: isFocused,
        customClasses: (0, _keys2.default)(utils.filterCustomClasses(day)(customClasses)),
        colors: colors,
        classes: classes
      });
    }, week));
  }, (0, _splitEvery2.default)(7, toRender))));
};

var _default = CalendarMonth;
exports.default = _default;