"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.getClasses = void 0;

var _isEmpty2 = _interopRequireDefault(require("ramda/src/isEmpty"));

var React = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  display: table-cell;\n  box-sizing: border-box;\n  border: 1px solid #e4e7e7;\n\n  .hidden {\n    border: none;\n  }\n  .hidden-btn {\n    opacity: 0;\n  }\n  .disabled-btn {\n    color: gray;\n    background: white;\n    cursor: default;\n    :hover {\n      color: gray;\n      background: inherit;\n    }\n  }\n  .hovered-btn {\n    color: white;\n    background: #008000;\n    :hover {\n      background: #008000;\n    }\n  }\n  .focused-btn {\n    color: inherit;\n    background: white;\n    :hover {\n      background: #008000;\n      color: white;\n    }\n  }\n  .selected-btn {\n    color: white;\n    background: #008000;\n    :hover {\n      background: #329b24;\n      color: white;\n    }\n  }\n  .default-btn {\n    color: inherit;\n    background: white;\n    :hover {\n      color: inherit;\n      background: #e4e7e7;\n    }\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  width: 100%;\n  height: 40px;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  border: none;\n  cursor: pointer;\n  border-radius: 0;\n  :focus {\n    outline: none;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var getClasses = function getClasses(props) {
  var isBtn = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  if (props.isHidden) {
    return isBtn ? "hidden-btn" : "hidden";
  }

  if (props.isDisabled) {
    return isBtn ? "disabled-btn" : "disabled";
  }

  if (props.isHovered) {
    return isBtn ? "hovered-btn" : "hovered";
  }

  if (props.isSelected) {
    return isBtn ? "selected-btn" : "selected";
  }

  if (!(0, _isEmpty2.default)(props.classes)) {
    return isBtn ? "".concat(props.classes.join(" "), " default-btn") : "".concat(props.classes.join(" "), " default");
  }

  return isBtn ? "default-btn" : "default";
};

exports.getClasses = getClasses;

var Button = _styledComponents.default.button(_templateObject());

var Td = _styledComponents.default.div(_templateObject2());

var CustomDay =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(CustomDay, _React$PureComponent);

  function CustomDay() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, CustomDay);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(CustomDay)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleClick", function () {
      var _this$props = _this.props,
          selectDate = _this$props.selectDate,
          value = _this$props.value;
      selectDate(value);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleHover", function () {
      var _this$props2 = _this.props,
          onHover = _this$props2.onHover,
          value = _this$props2.value;
      onHover(value);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "props", void 0);

    return _this;
  }

  _createClass(CustomDay, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          isHidden = _this$props3.isHidden,
          number = _this$props3.number,
          isPast = _this$props3.isPast,
          isFuture = _this$props3.isFuture,
          isSelected = _this$props3.isSelected,
          isDisabled = _this$props3.isDisabled,
          isHovered = _this$props3.isHovered,
          isFocused = _this$props3.isFocused,
          classes = _this$props3.classes;
      return React.createElement(Td, {
        className: getClasses({
          isHidden: isHidden,
          isSelected: isSelected,
          isFocused: isFocused,
          isDisabled: isDisabled,
          isHovered: isHovered,
          classes: classes
        }),
        isHidden: isHidden
      }, React.createElement(Button, {
        className: getClasses({
          isHidden: isHidden,
          isSelected: isSelected,
          isFocused: isFocused,
          isDisabled: isDisabled,
          isHovered: isHovered,
          classes: classes
        }, true),
        onClick: this.handleClick,
        onMouseOver: this.handleHover,
        onFocus: this.handleHover,
        disabled: isPast || isFuture || isDisabled,
        isSelected: isSelected,
        isHidden: isHidden,
        isPast: isPast,
        isFuture: isFuture,
        isHovered: isHovered,
        isDisabled: isDisabled,
        isFocused: isFocused,
        number: number
      }, number));
    }
  }]);

  return CustomDay;
}(React.PureComponent);

exports.default = CustomDay;