"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isHovered = exports.isDisabled = exports.isSelected = exports.isFuture = exports.isPast = void 0;

var _find2 = _interopRequireDefault(require("ramda/src/find"));

var _isBefore = _interopRequireDefault(require("date-fns/isBefore"));

var _isAfter = _interopRequireDefault(require("date-fns/isAfter"));

var _isSameDay = _interopRequireDefault(require("date-fns/isSameDay"));

var _startOfDay = _interopRequireDefault(require("date-fns/startOfDay"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isPast = function isPast(day, date) {
  return (0, _isBefore.default)(day, (0, _startOfDay.default)(date));
};

exports.isPast = isPast;

var isFuture = function isFuture(day, date) {
  return (0, _isAfter.default)(day, (0, _startOfDay.default)(date));
};

exports.isFuture = isFuture;

var isSelected = function isSelected(day, selectedDates) {
  return Boolean((0, _find2.default)(function (selected) {
    return (0, _isSameDay.default)(selected, day);
  }, selectedDates));
};

exports.isSelected = isSelected;

var isDisabled = function isDisabled(day, disabledDates) {
  return Boolean((0, _find2.default)(function (disabled) {
    return (0, _isSameDay.default)(disabled, day);
  }, disabledDates));
};

exports.isDisabled = isDisabled;

var isHovered = function isHovered(day, hoveredDates) {
  return Boolean((0, _find2.default)(function (hovered) {
    return (0, _isSameDay.default)(hovered, day);
  }, hoveredDates));
};

exports.isHovered = isHovered;